#include <io.h>
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <gdata.h>
#include <ggraph.h>
#include <pcx.h>
#include <cret.h>
#include <cgraph.h>

fixed vec_len(fixed x, fixed y)
{
    double fx, fy, dist;

    fx = x/256;
    fy = y/256;
    dist = sqrt((fx*fx) + (fy*fy));
    return (fixed)(dist*256);
}

int Find_Closest_Cret(int c)
{
    int ch, last_cret = -1;
    fixed last_dist=999999, cur_dist;


    for(ch=0; ch<NUMCREATURES; ch++)
    if(c != ch && cret[ch].alive == YES)
    {
        cur_dist = vec_len(cret[ch].x - cret[c].x, cret[ch].y - cret[c].y);
        if(cur_dist == 0) return ch;
        if(cur_dist < last_dist) {
            last_dist = cur_dist;
            last_cret = ch;
        }
    }
    return last_cret;
}

void Centroid()
{
    int c, n=0;
    fixed xsum=0, ysum=0;
    point cent;
    for(c=0; c<NUMCREATURES; c++)
    if(cret[c].alive == YES) {
        n++;
        xsum += cret[c].x;
        ysum += cret[c].y;
    }
    if(n==0)
    {
        gx = (fixed)160<<8;
        gy = (fixed)100<<8;
        return;
    }
    gx = (xsum/n);
    gy = (ysum/n);

}

int calc_angle(fixed cosval, fixed sinval)
{
    int ang,
        best_ang;
    fixed best_dist=99999,
          dist;

    for(ang=1; ang<1919; ang++)
    {
        dist = fabs((cos_table[ang]-cosval)) + fabs((sin_table[ang]-sinval));
        if(dist == 0) return ang;
        if(dist < best_dist)
        {

            best_dist = dist;
            best_ang = ang;
        }
    }
    return best_ang;

}

void pset(int x, int y, unsigned char color)
{
    if (x > 0 && x < 320)
    if (y > 0 && y < 200)
    double_buffer[x + (y<<8) + (y<<6)] = color;
}

void Draw_Rot(int pic, int sx, int sy, int angle, int flip)
{
unsigned char color;
int x, y,
    bx, by;
fixed cosval = cos_table[angle],
      sinval = sin_table[angle],
      u, v, DuCol, DvCol, DuRow, DvRow,
      startU, startV;
int graphic_size_x = bmap_sizes[pic].x,
    graphic_size_y = bmap_sizes[pic].y;
fixed graphic_size_x_f = graphic_size_x<<8,
      graphic_size_y_f = graphic_size_y<<8;
int half_size_x = (bmap_sizes[pic].x)>>1,
    half_size_y = (bmap_sizes[pic].y)>>1;
unsigned int bmp_off, vid_off, next_vidrow_off;
char far *tmp_ptr = bmap_ptr[pic];

    vid_off = (sx-half_size_x) + (sy-half_size_y)*320;
    next_vidrow_off = 320-(half_size_x<<1);

// u = xcos + ysin, v = -xsin + ycos;

    DuCol = cosval;
    DvCol = -sinval;
    DuRow = sinval;
    DvRow = cosval;

// The inside loop could be optimized a bit, but other than that it's pretty
// good.
    startU = (half_size_x<<8) + (-half_size_x*cosval) + -half_size_y*sinval;
    startV = (half_size_y<<8) + (half_size_x*sinval) + -half_size_y*cosval;

    for(y = -half_size_y; y<half_size_y; y++)
    {
        // u = x cos + y sin
        // v = -x sin + y cos
        u = startU;
        v = startV;
        for(x = -half_size_x; x<half_size_x; x++)
        {
            if(u < graphic_size_x_f-1 && v < graphic_size_y_f)
            if(u > 0 && v > 0)
            {
                bx = (int)(u>>8);
                by = (int)(v>>8);
                if(flip & 1)
                bx = (graphic_size_x-1)-bx;
                if(flip & 2)
                by = (graphic_size_y-1)-by;

                bmp_off = bx + (by*graphic_size_x);
                color = tmp_ptr[bmp_off];
                if(color)
                double_buffer[vid_off]=color;
            }
            vid_off++;
            u += DuCol;
            v += DvCol;
        }
        vid_off += next_vidrow_off;
        startU += DuRow;
        startV += DvRow;
    }
}

