#define PICS_IN_SEQUENCE        5
#define NUMACTS                 10
#define NUMBCKS                 10
// States that the creatures may be in
#define STATE_WAIT              0
#define STATE_MOVE              1
#define STATE_HUNT              2
#define STATE_EAT               3
#define STATE_RUN               4       // Run from a specific creature
#define STATE_DYING             5
#define STATE_DEAD              6
#define STATE_ISFOOD            7
#define STATE_SQUASH            8
#define STATE_SQUASHW           9
#define STATE_YUMM              10

// Actions
#define ACT_NOTHING             0
#define ACT_HUNT                1       // Pick a creature and eat it
#define ACT_CONG                2       // congregate
#define ACT_HIDE                3       // Move away from the group
#define ACT_WIERD               4       // Do something wierd/funny

#define YES                     1
#define NO                      0

#define NUMCREATURES            10
#define K_GRAV                  150     // (fixed)
#define K_GRAV_WATER            7       // (fixed)
#define K_WATER_FRICTION        0.009

#define K_CRET_TOPSPEED         300     // Terminal Velocity of the creature (fixed)
#define K_CRET_MOV              0.23   // Normal movement acceleration speed
#define K_CRET_EATSPEED         0.45    // Accel rate of the creatures when they are hunting
#define K_CRET_TURNRATE         1000    // Rate at which the creatures turn ... Not really used(now)
#define K_CRET_ELASTICITY       0.8
#define K_EATRANGE              3000     // Fixed distance... Divide by 256 to get real
#define K_EATPOINTS             100
#define K_CRETNEARBY            3500
#define K_CRETHUNGRY            700      // Number of passes before the cret gets hungry
// Time after which the creature dies of hunger.. This is not really in the program right now.
#define K_CRETHUNGDED           1000

fixed gx, gy;

struct anim {
        int num_frames;
        int repeats;            // YES or NO... If no, go back to wait state when done.
        int delay;              // How long each frame is displayed for
        int pic[PICS_IN_SEQUENCE];
};

typedef struct point_typ {
        fixed x;
        fixed y;
} point, *point_ptr;

struct {                        // Background items.. Not in yet.
        int x;
        int y;
        int z;
        int pic;
} bcks[NUMBCKS];

typedef struct creature_type {
        int alive;
// Personality variables (below)
        int hpx;        // hit points
        long score;
// Rank of creature
        int str;        // How many hit points are taken away in an attack by this creature
        int pers;       // Persistence - probability of chasing a victim.
        int fear;       // Probability of running when another creature is nearby
        fixed xv;       // velocity
        fixed yv;
        fixed x;        // position on the screen
        fixed y;
        int angle;
        fixed target_a;
        fixed target_b;
// Location ^^ and physics variables
        int actions[NUMACTS+10];
// A list of actions that are performed...
        int cur_state;
        int counter;            // Counter for ai functoins
        int eat_time;           // Time since he has last eaten
        struct anim frame;
        int cur_frame;
        int frame_time;         // How long the current frame has been displayed for
} creature;
creature cret[NUMCREATURES];
